function load_wice_ticket_view() {

    var browser = document.getElementById("messagepane");
    var url = get_wice_url() + "/pserv/base/ticket";

    //var realmessage = get_message_text(); // not good because realmessage might be base64-encoded. Better use the following line:
    var realmessage = browser.contentDocument.body.innerHTML;
    if(!realmessage) { alert("no msg"); return; }


    // fetch ticket id:
    var ticket_id = 0;
    if(realmessage.match(/Ticket ID (\d+)/))
	ticket_id = realmessage.match(/Ticket ID (\d+)/)[1];
    else if(realmessage.match(/Vorgangs-ID (\d+)/))
	ticket_id = realmessage.match(/Vorgangs-ID (\d+)/)[1];
    else if(realmessage.match(/Vorgangs-ID: (\d+)/))
	ticket_id = realmessage.match(/Vorgangs-ID: (\d+)/)[1];
    else if(realmessage.match(/Vorgangs-ID:(\d+)/))
	ticket_id = realmessage.match(/Vorgangs-ID:(\d+)/)[1];
    else if(realmessage.match(/Ticket ID: (\d+)/))
	ticket_id = realmessage.match(/Ticket ID: (\d+)/)[1];

    url += "?tab=replies&edit_entry="+ticket_id;
    messenger.launchExternalURL(url);
}


function save_in_wice() {
    // read message ('content' will be filled with full mime message with attachment):
    var content = "";
    //var MessageURI = GetFirstSelectedMessage();
    var MessageURI = gFolderDisplay.selectedMessageUris[0]; // since TB 3
    if(!MessageURI) {
	alert(unescape("Bitte w%E4hlen Sie erst eine Nachricht aus."));
	return;
    }

    var MsgService = messenger.messageServiceFromURI(MessageURI);
    var MsgStream = Components.classes["@mozilla.org/network/sync-stream-listener;1"].createInstance();
    var MsgStrem_Inputstream = MsgStream.QueryInterface(Components.interfaces.nsIInputStream);
    var ScriptInput = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance();
    var ScriptInputStream = ScriptInput .QueryInterface(Components.interfaces.nsIScriptableInputStream);
    ScriptInputStream .init(MsgStream);
    try	{
	MsgService .streamMessage(MessageURI,MsgStream, msgWindow, null, false, null);
    } catch (ex) {
	return;
    }
    ScriptInputStream .available();
    while (ScriptInputStream .available()) {
	content = content + ScriptInputStream .read(512);
    }

    /*
    var numNodes = firstattachment.childNodes.length;
    var text = "";
    for(i=0;i<numNodes;i++) {
	text += " --- VAL"+i+": "+firstattachment.childNodes[i].nodeName+"="+firstattachment.childNodes[i].nodeValue;
    }
    */

    // send post request to thunderbird connector script:
    var url = get_wice_url() + "/pserv/base/thunderbird";

    // get cookie
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    prefs = prefs.getBranch("extensions.tbwice_thunderbird.");

    // during escaping and unescaping (in thunderbird script in WICE), plus signs get converted to spaces. We must prevent this:
    content = content.replace(/\+/g, "|PLUS|");
    var message_uri_clean = MessageURI;//.replace(/\&/g, "|AMPERSAND|");
    var par = "cookie="+prefs.getCharPref("wice_cookie")+"&save_message=1&message_uri="+escape(message_uri_clean)+"&content="+escape(content);
    makePOSTRequest(url, par); // will load save form in messagepane

}


function makePOSTRequest(url, parameters) {
    http_request = false;
    if (window.XMLHttpRequest) { // Mozilla, Safari,...
	http_request = new XMLHttpRequest();
	if (http_request.overrideMimeType) {
	    // set type accordingly to anticipated content type
            //http_request.overrideMimeType('text/xml');
            http_request.overrideMimeType('text/html');
	}
    } else if (window.ActiveXObject) { // IE
	try {
            http_request = new ActiveXObject("Msxml2.XMLHTTP");
	} catch (e) {
            try {
		http_request = new ActiveXObject("Microsoft.XMLHTTP");
            } catch (e) {}
	}
    }
    if (!http_request) {
	alert('Cannot create XMLHTTP instance');
	return false;
    }

    http_request.onreadystatechange = alertContents; // please read notes about this in the function directly

    http_request.open('POST', url, true);
    http_request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    http_request.setRequestHeader("Content-length", parameters.length);
    http_request.setRequestHeader("Connection", "close");
    http_request.send(parameters);
}


function alertContents() {
    if (http_request.readyState == 4) {
	if (http_request.status == 200) {
            //alert(http_request.responseText);
            var response = http_request.responseText; // contains escaped message_uri
            var browser = document.getElementById("messagepane");

	    // alert("RESPONSE FROM WICE SERVER: "+response);
	    if(response.startsWith("Bitte klicken Sie")) { // invalid session
		alert(response);
		return;
	    }
	    var messageURI = gFolderDisplay.selectedMessageUris[0]; // we better use this rather than http_request.responseText (Protonet server will fuck up the responseText with HTML code)


	    // note: we can not populate the messagepane directly. Something like "browser.innerHTML='OK';return;" does not work. Also see http://thunderbirddocs.blogspot.com/2005/08/populating-messagepane-in-thunderbird.html about this.
            // our workaround: requesting another url from the thunderbird script on the wice server:
	    
	    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	    prefs = prefs.getBranch("extensions.tbwice_thunderbird.");
	    var url = get_wice_url() + "/pserv/base/thunderbird";
	    // browser.loadURI(url+"?cookie="+prefs.getCharPref("wice_cookie")+"&show_last_content=1&message_uri="+response, browser.currentURL, null);
	    browser.loadURI(url+"?cookie="+prefs.getCharPref("wice_cookie")+"&show_last_content=1&message_uri="+escape(messageURI), browser.currentURL, null);

	} else {
            alert('Es ist ein Server-Fehler aufgetreten.');
	}
    }
}


function get_wice_url() { // return something like http://wicegmbh/pserv/base/ticket?cookie=85yt4lfn3x05qdjfm5ngqi2oarb1qyj9

    // https://developer.mozilla.org/en-US/docs/Archive/Add-ons/Code_snippets/Preferences
/*
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
    .getService(Components.interfaces.nsIPrefService).getBranch("accessibility.");
*/    
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    prefs = prefs.getBranch("extensions.tbwice_thunderbird.");

    var wice_server_url;
    
    try {
	wice_server_url = prefs.getCharPref("wice_server");
    } catch(error) {
	alert("Bitte klicken Sie auf 'Wice Login' unten rechts in Thunderbird.");
	return;
    }

    // console.log("Wice URL "+wice_server_url);
    return wice_server_url;

}
