window.addEventListener("load", function() { myExtension.init(); }, false);

var myExtension = {
    init: function() {
	var appcontent = document.getElementById("appcontent");   // browser
	if(appcontent)
	    appcontent.addEventListener("DOMContentLoaded", this.onPageLoad, true);
	var messagepane = document.getElementById("messagepane"); // mail
	if(messagepane)
	    messagepane.addEventListener("load", this.onPageLoad, true);
    },
    
    onPageLoad: function(aEvent) {
	
	var doc = aEvent.originalTarget;  // doc is document that triggered "onload" event

	var realmessage = doc.body.innerHTML;

	if(!realmessage) { return }

	// fetch ticket id:
	var ticket_id = 0;
	if(realmessage.match(/Ticket ID (\d+)/))
	    ticket_id = realmessage.match(/Ticket ID (\d+)/)[1];
	else if(realmessage.match(/Ticket ID: (\d+)/))
	    ticket_id = realmessage.match(/Ticket ID: (\d+)/)[1];
	else if(realmessage.match(/Vorgangs-ID (\d+)/))
	    ticket_id = realmessage.match(/Vorgangs-ID (\d+)/)[1];
	else if(realmessage.match(/Vorgangs-ID:(\d+)/))
	    ticket_id = realmessage.match(/Vorgangs-ID:(\d+)/)[1];
	else if(realmessage.match(/Vorgangs-ID: (\d+)/))
	    ticket_id = realmessage.match(/Vorgangs-ID: (\d+)/)[1];
	
	if(ticket_id>0)
	    document.getElementById('my-panel').label="WICE-Vorgangsansicht";
	else
	    document.getElementById('my-panel').label="";
	//alert("HREF"+doc.location.href);
    }
}

